commit 33f30a7d8b2420ea9c7f83e2784f33d5a9fa14a0
Author: Christophe Lyon <christophe.lyon@linaro.org>
Date:   Thu Sep 18 18:41:19 2025

    arm: add support for out of range shift amount in MVE asrl and lsll [PR122216]
    
    MVE asrl and lsll instructions have two variants:
    - immediate shift amount in the [1..32] range
    - shift amount in a register, where negative values reverse the
      direction of the shift
    
    However, RTL assumes that the shift amount is interpreted unsigned, so
    we want to make sure undesired simplifications do not take place.
    For instance if simplify_rtx optimizes
    (set (reg:SI 1) (const_int -5))
    (set (reg:DI 2) (ashift:DI (reg:DI 3) (reg:SI 1)))
    into:
    (set (reg:DI 2) (ashift:DI (reg:DI 3) (const_int -5)))
    we do not want this to be interpreted as undefined behavior.
    
    We handle this using a general pattern where:
    - immediates are handled by a define_insn_and_split pattern which
      directly maps immediates in [1..32] to the shift operator and splits
      other cases as needed.
    - non-immediates are handled by another pattern
    
    gcc/ChangeLog:
    
            PR target/122216
            * config/arm/arm.md (ashldi3, ashrdi3): Force shift amount into
            QImode.
            * config/arm/constraints.md: Fix comment, Pg is valid in Thumb-2
            state only.
            * config/arm/mve.md (mve_asrl): Handle various shift amount ranges.
            (mve_asrl_imm, mve_asrl_internal): New patterns.
            (mve_lsll): Handle various shift amount ranges.
            (mve_lsll_imm, mve_lsll_internal): New patterns.
    
    gcc/testsuite/ChangeLog:
    
            PR target/122216
            * gcc.target/arm/mve/intrinsics/asrl-various-ranges.c: New test.
            * gcc.target/arm/mve/intrinsics/lsll-various-ranges.c: New test.

diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/asrl-various-ranges.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/asrl-various-ranges.c
new file mode 100644
index 00000000000..4e2a301863d
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/asrl-various-ranges.c
@@ -0,0 +1,161 @@
+/* { dg-require-effective-target arm_v8_1m_mve_ok } */
+/* { dg-add-options arm_v8_1m_mve } */
+/* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
+
+/* Check that calling asrl with an out of range shift amount is not interpreted
+   as undefined behavior, and that we actually use the asrl instruction (except
+   if a negative shift amount can be handled by lsll).  Check code generation
+   for various special cases:
+   1 <= amount <= 32
+   -32 <= amount <= -1
+   32 < amount < 64
+   -64 < amount < -32
+   amount >= 64
+   amount <= -64
+   amount == 0
+   amount unknown at compile time. */
+#include "arm_mve.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+  /* Positive shift amount in [1.32] range, use the immediate:
+
+   asrl r0, r1, #3  */
+/*
+**foo_3:
+**	...
+**	asrl	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #3(?:	@.*|)
+**	...
+*/
+int64_t
+foo_3 (int64_t value)
+{
+  return asrl (value, 3);
+}
+
+  /* Negative shift amount in [-32.-1] range, reverse shift (lsll) with the
+     opposite shift amount as immediate:
+
+     lsll r0, r1, #3  */
+/*
+**foo_m3:
+**	...
+**	lsll	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #3(?:	@.*|)
+**	...
+*/
+int64_t
+foo_m3 (int64_t value)
+{
+  return asrl (value, -3);
+}
+
+  /* Out of [1.32] range positive shift amount, but < 64.
+     lo_out = hi_in >> (amount - 32)
+     hi_out = hi_in >> 31 (to copy the sign bit)
+
+     asrs r0, r1, #1
+     asrs r1, r1, #31   */
+/*
+**foo_33:
+**	...
+**	asrs	(?:ip|fp|r[0-9]+), (ip|fp|r[0-9]+), #1(?:	@.*|)
+**	asrs	(?:ip|fp|r[0-9]+), \1, #31(?:	@.*|)
+**	...
+*/
+int64_t
+foo_33 (int64_t value)
+{
+  return asrl (value, 33);
+}
+
+  /* Out of [-32..-1] range negative shift amount, but > -64. Reverse shift
+     (lsll equivalent) in [33.64] range:
+     hi_out = lo_in << (-amount - 32)
+     lo_out = 0 
+
+     lsls r1, r0, #1
+     movs r0, #0  */
+/*
+**foo_m33:
+**	...
+**	lsls	(?:ip|fp|r[0-9]+), (ip|fp|r[0-9]+), #1(?:	@.*|)
+**	movs	\1, #0(?:	@.*|)
+**	...
+*/
+int64_t
+foo_m33 (int64_t value)
+{
+  return asrl (value, -33);
+}
+
+  /* Out of range positive shift amount (>= 64)
+     lo_out = hi_in >> 31 (copy sign bit)
+     hi_out = hi_in >> 31
+
+     asrs r0, r1, #31
+     mov r1, r0  */
+/*
+**foo_65:
+**	...
+**	asrs	(ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #31(?:	@.*|)
+**	mov	(?:ip|fp|r[0-9]+), \1(?:	@.*|)
+**	...
+*/
+int64_t
+foo_65 (int64_t value)
+{
+  return asrl (value, 65);
+}
+
+  /* Out of range negative shift amount (<= 64), result is 0.
+
+   movs r0, #0
+   movs r1, #0  */
+/*
+**foo_m65:
+**	...
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	...
+*/
+int64_t
+foo_m65 (int64_t value)
+{
+  return asrl (value, -65);
+}
+
+  /* shift amount == 0, use a mov, which is optimized out.  */
+/*
+**foo_0:
+**	bx	lr
+**	...
+*/
+int64_t
+foo_0 (int64_t value)
+{
+  return asrl (value, 0);
+}
+
+  /* Unknown shift amount, use the register variant.
+
+     asrl r0, r1, r2  */
+/*
+**foo_var:
+**	...
+**	asrl	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+*/
+int64_t
+foo_var (int64_t value, int32_t amount)
+{
+  return asrl (value, amount);
+}
+
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/lsll-various-ranges.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/lsll-various-ranges.c
new file mode 100644
index 00000000000..1e2f558af88
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/lsll-various-ranges.c
@@ -0,0 +1,160 @@
+ /* { dg-require-effective-target arm_v8_1m_mve_ok } */
+/* { dg-add-options arm_v8_1m_mve } */
+/* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
+
+/* Check that calling lsll with an out of range shift amount is not interpreted
+   as undefined behavior, and that we actually use the lsll instruction (except
+   if a negative shift amount can be handled by asrl).  Check code generation
+   for various special cases:
+   1 <= amount <= 32
+   -32 <= amount <= -1
+   32 < amount < 64
+   -64 < amount < -32
+   amount >= 64
+   amount <= -64
+   amount == 0
+   amount unknown at compile time. */
+#include "arm_mve.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+  /* Positive shift amount in [1.32] range, use the immediate:
+
+     lsll r0,r1,#3  */
+/*
+**foo_3:
+**	...
+**	lsll	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #3(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_3 (uint64_t value)
+{
+  return lsll (value, 3);
+}
+
+  /* Negative shift amount in [-32.-1] range, reverse shift (asrl) with the
+     opposite shift amount as immediate:
+
+     lsrl r0, r1, #3  */
+/*
+**foo_m3:
+**	...
+**	lsrl	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #3(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_m3 (uint64_t value)
+{
+  return lsll (value, -3);
+}
+
+  /* Out of [1..32] range positive shift amount, but < 64.
+     high_out = low_in << (amount - 32) (using lsls, not lsll)
+     low_out = 0
+
+     lsls r1,r0,#1
+     movs r0, #0  */
+/*
+**foo_33:
+**	...
+**	lsls	(?:ip|fp|r[0-9]+), (ip|fp|r[0-9]+), #1(?:	@.*|)
+**	movs	\1, #0(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_33 (uint64_t value)
+{
+  return lsll (value, 33);
+}
+
+  /* Out of [-32..-1] range negative shift amount, but > -64.  Reverse shift
+     (lsrl equivalent) in [33..64] range:
+     lo_out = hi_in >> (amount - 32)
+     hi_out = 0
+
+     lsrs r0, r1, #1
+     movs r1, #0  */
+/*
+**foo_m33:
+**	...
+**	lsrs	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), #1(?:	@.*|)
+**	movs	(?:ip|fp|r[0-9]+), #0(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_m33 (uint64_t value)
+{
+  return lsll (value, -33);
+}
+
+  /* Out of range positive shift amount (>= 64), result is 0.
+
+     movs r0, #0
+     movs r1, #0  */
+/*
+**foo_65:
+**	...
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_65 (uint64_t value)
+{
+  return lsll (value, 65);
+}
+
+  /* Out of range negative shift amount (<= -64), result is 0, because lsll
+     uses an unsigned input.
+
+     movs r0, #0
+     movs r1, #0  */
+/*
+**foo_m65:
+**	...
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	movs	(ip|fp|r[0-9]+), #0(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_m65 (uint64_t value)
+{
+  return lsll (value, -65);
+}
+
+  /* shift amount == 0, use a mov, which is optimized out.  */
+/*
+**foo_0:
+**	bx	lr
+**	...
+*/
+uint64_t
+foo_0 (uint64_t value)
+{
+  return lsll (value, 0);
+}
+
+  /* Unknown shift amount, use the register variant.
+
+   lsll r0, r1, r2  */
+/*
+**foo_var:
+**	...
+**	lsll	(?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+), (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+*/
+uint64_t
+foo_var (uint64_t value, int32_t amount)
+{
+  return lsll (value, amount);
+}
+
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */

